/*
 * Options.h
 *
 *      Author: Trax
 */

#ifndef OPTIONS_H_
#define OPTIONS_H_

typedef struct
{
	uint8_t	Input;
	uint16_t InValue;

	uint16_t Aux;

	uint8_t	Output;
	uint16_t OutValue;
} tOption;


#define LO		0
#define HI		1
#define LO_S	2
#define HI_S	3

#define AND		2
#define NOT_AND	3
#define AND_NOT	4
#define NOR		5
#define OR		6
#define NOT_OR	7
#define OR_NOT	8
#define NAND	9
#define XOR		10
#define XNOR	11

#define EQ_VAL 	0
#define GT_VAL 	1
#define LT_VAL 	2
#define NE_VAL 	3
#define EQ_CHN 	4
#define GT_CHN 	5
#define LT_CHN 	6
#define NE_CHN 	7

int GetOptCount();

int GetOptIn(int i);
void SetOptIn(int i, int Val);
int GetOptInVal(int i);
void SetOptInVal(int i, int Val);
int GetOptAux(int i);
void SetOptAux(int i, int Val);
int GetOptOut(int i);
void SetOptOut(int i, int Val);
int GetOptOutVal(int i);
void SetOptOutVal(int i, int Val);

void AddOption(uint8_t* Opt);
void UpOption(int i);
void RemoveOption(int i);
void DownOption(int i);

void MgmtDo();

#endif /* OPTIONS_H_ */
