/*
 * Ports.h
 *
 *      Author: Trax
 */

#include <stdint.h>

#ifndef PORTS_H_
#define PORTS_H_

typedef struct
{
	volatile uint8_t*   pPin;
	volatile uint8_t*   pPort;
	volatile uint8_t*   pDdr;
	uint8_t 			nBit;
	uint8_t				nADC;
	uint8_t				nPWM;

	char 				ID[3];

	char* 				Label;
	uint8_t 			IO;
} tGpio;


typedef struct
{
	uint8_t nBit;
	char ID[3];
	char* Label;

	uint8_t IO;
} tVPort;

#define OUTPUT		0
#define INPUT		1
#define INPUT_ADC	2
#define OUTPUT_PWM	3
#define MEMORY		4
#define MEMORY_SW	5

#define LC_RS		7
#define LC_EN		8
#define LC_D4		9
#define LC_D5		10
#define LC_D6		11
#define LC_D7		12
#define LC_SL		13
#define LC_SR		14

#define NONE		0xFF

int GetPortCount();
int GetHWPortCount();

uint8_t GetPortADC(int Port);
uint8_t GetPortPWM(int Port);
uint8_t GetPortMEM(int Port);
char* GetPortID(int Port);
char* GetPortLabel(int Port, uint8_t UseID);
void SetPortLabel(int Port, const char* NewLabel);
int GetPortIO(int Port);
void SetPortIO(int Port, uint8_t IO);
int GetPort(const char *pID);

void SetBitIO(int Port, uint8_t O);
uint8_t GetBit(int Port);
void SetBit(int Port, uint8_t Bit);

uint16_t GetVal(int Port);
void SetVal(int Port, uint16_t Val);

uint16_t ReadChannel(uint8_t mux);

#define ARRSIZE(x) (sizeof(x)/sizeof(x[0]))

#endif /* PORTS_H_ */
