/*
 * Options.h
 *
 *      Author: Trax
 */

#ifndef SCREENS_H_
#define SCREENS_H_

typedef struct {
	const char c[3];
	volatile uint8_t Port;
	const uint8_t DefPort;
	const uint8_t IO;
} tLCDPins;

#define RS 0
#define EN 1
#define D4 2
#define D5 3
#define D6 4
#define D7 5
#define SL 6
#define SR 7

typedef struct
{
	char* L[4];
	uint16_t Action;
} tScreen;

const char* GetLCDPin(int Port);

int GetLCDSupport();
void SetLCDSupport(int LCD);

int GetLCDPort(int Port);

int GetLCDLines();
void SetLCDLines(int Lines);
char* GetLCDPinID(int Pin);
void SetLCDPin(int Pin, int Port);
int GetLCDAuto();
void SetLCDAuto(int Auto);

int GetScrCount();

char* GetScr(int i, int j);
void SetScr(int i, int j, const char* Scr);
int GetScrAction(int i);
void SetScrAction(int i, uint8_t Action);
void AddScreen();
void UpScreen(int i);
void RemoveScreen(int i);
void DownScreen(int i);

void InitScreen();
void SwitchPage(uint8_t nSL, uint8_t nSR);

#endif /* SCREENS_H_ */
